package ru.ifmo.vizi.dmkm;

import ru.ifmo.vizi.base.auto.*;
import java.util.Locale;

public final class DMKM extends BaseAutomataWithListener {
    /**
      *  .
      */
    public final Data d = new Data();

    /**
      *   
      */
    public DMKM(Locale locale) {
        super("ru.ifmo.vizi.dmkm.Comments", locale); 
        init(new Main(), d); 
    }

    /**
      * .
      */
    public final class Data {
        /**
          *  .
          */
        public DMKMVisualizer vis;

        /**
          *  .
          */
        public int g[][];

        /**
          *   ( ).
          */
        public int dg[][];

        /**
          * .
          */
        public int f[][];

        /**
          * -.
          */
        public int df[][];

        /**
          * .
          */
        public int p[];

        /**
          *  .
          */
        public int pin[];

        /**
          *  .
          */
        public int pout[];

        /**
          *   .
          */
        public boolean del[];

        /**
          *    .
          */
        public int n;

        /**
          * .
          */
        public int s;

        /**
          * .
          */
        public int t;

        /**
          *    .
          */
        public int minv;

        /**
          *     .
          */
        public boolean isNetwork;

        /**
          *    .
          */
        public boolean isDel;

        /**
          * ,        forward(backward).
          */
        public boolean newArc[][];

        /**
          * ,       .
          */
        public boolean newFlowArc[][];

        /**
          *        get_minv.
          */
        public boolean isFirstGetMinv;

        /**
          * maxint.
          */
        public final int maxint = Integer.MAX_VALUE;

        /**
          *   .
          */
        public int resultFlow;

        /**
          *  .
          */
        public int minp;

        /**
          *  - .
          */
        public int pseudoResultFlow;

        /**
          *  .
          */
        public int k, c1, c2, q1[], q2[], dst[], i, j, pr, pw, dpr, dpw, delta, fl[], q[], dq[];

        /**
          *  .
          */
        public char sj, si;

        /**
          *  .
          */
        public boolean isFirstDelete, diniz[];

        public String toString() {
            return "";
        }
    }

    /**
      *   .
      */
    private final class MakeNetwork extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 21;

        /**
          * .
          */
        public MakeNetwork() {
            super( 
                "MakeNetwork", 
                0, //    
                21, //    
                new String[]{ 
                    " ",  
                    " ", 
                    "", 
                    "      ,       .", 
                    "", 
                    "  ", 
                    "  .", 
                    "", 
                    "", 
                    "    ", 
                    "     ()", 
                    ",   ", 
                    "", 
                    "", 
                    "     ", 
                    "IfDinizNetworkExist", 
                    "IfDinizNetworkExist ()", 
                    "LastLayerBuilt", 
                    "  ", 
                    "  ", 
                    "  ", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    1, //   
                    0, //  
                    -1, //       ,       . 
                    -1, //  
                    -1, //    
                    -1, //   . 
                    -1, //  
                    -1, //  
                    -1, //      
                    -1, //      () 
                    0, // ,    
                    -1, //  
                    -1, //  
                    -1, //       
                    -1, // IfDinizNetworkExist 
                    -1, // IfDinizNetworkExist () 
                    0, // LastLayerBuilt 
                    1, //    
                    1, //    
                    -1, //    
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; //  
                    break;
                }
                case 1: { //  
                    state = 2; 
                    break;
                }
                case 2: { 
                    stack.pushBoolean(false); 
                    state = 3; //       ,       .
                    break;
                }
                case 3: { //       ,       .
                    if ((d.dst[d.t] == d.maxint) && (d.c2 > 0)) {
                        state = 4; // 
                    } else {
                        state = 14; //      
                    }
                    break;
                }
                case 4: { // 
                    stack.pushBoolean(false); 
                    state = 5; //   
                    break;
                }
                case 5: { //   
                    if (d.k < d.c1) {
                        state = 6; //   .
                    } else {
                        stack.pushBoolean(true); 
                        state = 3; //       ,       .
                    }
                    break;
                }
                case 6: { //   .
                    stack.pushBoolean(false); 
                    state = 7; 
                    break;
                }
                case 7: { 
                    if (d.j < d.n) {
                        state = 8; 
                    } else {
                        state = 13; 
                    }
                    break;
                }
                case 8: { 
                    state = 9; //     
                    break;
                }
                case 9: { //     
                    if (d.dg[d.i][d.j] > 0) {
                        state = 11; // ,   
                    } else {
                        stack.pushBoolean(false); 
                        state = 10; //      ()
                    }
                    break;
                }
                case 10: { //      ()
                    state = 12; 
                    break;
                }
                case 11: { // ,   
                    stack.pushBoolean(true); 
                    state = 10; //      ()
                    break;
                }
                case 12: { 
                    stack.pushBoolean(true); 
                    state = 7; 
                    break;
                }
                case 13: { 
                    stack.pushBoolean(true); 
                    state = 5; //   
                    break;
                }
                case 14: { //      
                    state = 15; // IfDinizNetworkExist
                    break;
                }
                case 15: { // IfDinizNetworkExist
                    if (d.isNetwork) {
                        state = 17; // LastLayerBuilt
                    } else {
                        stack.pushBoolean(false); 
                        state = 16; // IfDinizNetworkExist ()
                    }
                    break;
                }
                case 16: { // IfDinizNetworkExist ()
                    state = 20; //   
                    break;
                }
                case 17: { // LastLayerBuilt
                    state = 18; //   
                    break;
                }
                case 18: { //   
                    state = 19; //   
                    break;
                }
                case 19: { //   
                    stack.pushBoolean(true); 
                    state = 16; // IfDinizNetworkExist ()
                    break;
                }
                case 20: { //   
                    state = END_STATE; 
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //  
                    int i, j;
                    stack.pushInteger(d.c1);
                    stack.pushInteger(d.c2);
                    for (i = 0; i < d.n; i++)
                        stack.pushInteger(d.q1[i]);
                    for (i = 0; i < d.n; i++)
                        stack.pushInteger(d.q2[i]);
                    for (i = 0; i < d.n; i++)
                        stack.pushInteger(d.dst[i]);
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushInteger(d.dg[i][j]);
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushInteger(d.df[i][j]);
                    for (i = 0; i < d.n; i++)
                        stack.pushBoolean(d.del[i]);
                    
                    d.c1 = 0;
                    d.c2 = 1;
                    d.q2[0] = d.s;
                    for (i = 0; i < d.n; i++) d.dst[i] = d.maxint;
                    d.dst[d.s] = 0;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            d.dg[i][j] = d.df[i][j] = 0;
                    for (i = 0; i < d.n; i++)
                        d.del[i] = true;
                    break;
                }
                case 2: { 
                    d.del[0] = false;
                    break;
                }
                case 3: { //       ,       .
                    break;
                }
                case 4: { // 
                    int i;
                    for (i = 0; i < d.n; i++)
                        stack.pushInteger(d.q1[i]);
                    stack.pushInteger(d.c1);
                    stack.pushInteger(d.c2);
                    stack.pushInteger(d.k);
                    
                    for (i = 0; i < d.n; i++) d.q1[i] = d.q2[i];
                    d.c1 = d.c2;
                    d.c2 = 0;
                    d.k = 0;
                    break;
                }
                case 5: { //   
                    break;
                }
                case 6: { //   .
                    stack.pushInteger(d.i);
                    stack.pushInteger(d.j);
                    
                    d.i = d.q1[d.k];
                    d.j = 0;
                    break;
                }
                case 7: { 
                    break;
                }
                case 8: { 
                    int i, j;
                    stack.pushInteger(d.c2);
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushBoolean(d.newFlowArc[i][j]);
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushInteger(d.dg[i][j]);
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushInteger(d.df[i][j]);
                    for (i = 0; i < d.n; i++)
                        stack.pushInteger(d.dst[i]);
                    for (i = 0; i < d.n; i++)
                        stack.pushInteger(d.q2[i]);
                    
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            d.newFlowArc[i][j] = false;
                    if ( (d.dst[d.i] < d.dst[d.j]) && (d.g[d.i][d.j] > d.f[d.i][d.j]) ){
                        if (d.dst[d.j] == d.maxint) d.q2[d.c2++] = d.j;
                        d.dst[d.j] = d.dst[d.i] + 1;
                        d.dg[d.i][d.j] = d.g[d.i][d.j] - d.f[d.i][d.j];
                    }
                    if ( (d.dst[d.i] < d.dst[d.j]) && (d.f[d.j][d.i] > 0) ){
                        if (d.dst[d.j] == d.maxint) d.q2[d.c2++] = d.j;
                        d.dst[d.j] = d.dst[d.i] + 1;
                        d.dg[d.i][d.j] = d.f[d.j][d.i];
                    }
                    if (d.dg[d.i][d.j] > 0) d.newFlowArc[d.i][d.j] = true;
                    break;
                }
                case 9: { //     
                    break;
                }
                case 10: { //      ()
                    break;
                }
                case 11: { // ,   
                    stack.pushCharacter(d.si);
                    stack.pushCharacter(d.sj);
                    stack.pushBoolean(d.del[d.i]);
                    stack.pushBoolean(d.del[d.j]);
                    
                    if (d.i == 0) d.si = 's';
                    else if (d.i == d.n - 1) d.si = 't';
                    else d.si = (char)(d.i + 48);
                    if (d.j == 0) d.sj = 's';
                    else if (d.j == d.n - 1) d.sj = 't';
                    else d.sj = (char)(d.j + 48);
                    
                    d.del[d.i] = false;
                    d.del[d.j] = false;
                    break;
                }
                case 12: { 
                    d.j++;
                    break;
                }
                case 13: { 
                    d.k++;
                    break;
                }
                case 14: { //      
                    stack.pushBoolean(d.isNetwork);
                    
                    d.isNetwork = (d.dst[d.t] != d.maxint);
                    break;
                }
                case 15: { // IfDinizNetworkExist
                    break;
                }
                case 16: { // IfDinizNetworkExist ()
                    break;
                }
                case 17: { // LastLayerBuilt
                    int i, j;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushBoolean(d.newFlowArc[i][j]);
                    
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            d.newFlowArc[i][j] = false;
                    break;
                }
                case 18: { //   
                    break;
                }
                case 19: { //   
                    break;
                }
                case 20: { //   
                    int i;
                    for (i = 0; i < d.n; i++)
                        stack.pushBoolean(d.diniz[i]);
                    for (i = 0; i < d.n; i++)
                        d.diniz[i] = d.del[i];
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { //  
                    int i, j;
                    for (i = d.n - 1; i >= 0; i--)
                        d.del[i] = stack.popBoolean();
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.df[i][j] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.dg[i][j] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        d.dst[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        d.q2[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        d.q1[i] = stack.popInteger();
                    d.c2 = stack.popInteger();
                    d.c1 = stack.popInteger();
                    break;
                }
                case 2: { 
                    d.del[0] = true;
                    break;
                }
                case 3: { //       ,       .
                    break;
                }
                case 4: { // 
                    int i;
                    d.k = stack.popInteger();
                    d.c2 = stack.popInteger();
                    d.c1 = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        d.q1[i] = stack.popInteger();
                    break;
                }
                case 5: { //   
                    break;
                }
                case 6: { //   .
                    d.j = stack.popInteger();
                    d.i = stack.popInteger();
                    break;
                }
                case 7: { 
                    break;
                }
                case 8: { 
                    int i, j;
                    for (i = d.n - 1; i >= 0; i--)
                        d.q2[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        d.dst[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.df[i][j] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.dg[i][j] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.newFlowArc[i][j] = stack.popBoolean();
                    d.c2 = stack.popInteger();
                    break;
                }
                case 9: { //     
                    break;
                }
                case 10: { //      ()
                    break;
                }
                case 11: { // ,   
                    d.del[d.j] = stack.popBoolean();
                    d.del[d.i] = stack.popBoolean();
                    
                    d.sj = stack.popCharacter();
                    d.si = stack.popCharacter();
                    break;
                }
                case 12: { 
                    d.j--;
                    break;
                }
                case 13: { 
                    d.k--;
                    break;
                }
                case 14: { //      
                    d.isNetwork = stack.popBoolean();
                    break;
                }
                case 15: { // IfDinizNetworkExist
                    break;
                }
                case 16: { // IfDinizNetworkExist ()
                    break;
                }
                case 17: { // LastLayerBuilt
                    int i, j;
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.newFlowArc[i][j] = stack.popBoolean();
                    break;
                }
                case 18: { //   
                    break;
                }
                case 19: { //   
                    break;
                }
                case 20: { //   
                    for (int i = d.n - 1; i >= 0; i--)
                        d.diniz[i] = stack.popBoolean();
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //  
                    state = START_STATE; 
                    break;
                }
                case 2: { 
                    state = 1; //  
                    break;
                }
                case 3: { //       ,       .
                    if (stack.popBoolean()) {
                        state = 5; //   
                    } else {
                        state = 2; 
                    }
                    break;
                }
                case 4: { // 
                    state = 3; //       ,       .
                    break;
                }
                case 5: { //   
                    if (stack.popBoolean()) {
                        state = 13; 
                    } else {
                        state = 4; // 
                    }
                    break;
                }
                case 6: { //   .
                    state = 5; //   
                    break;
                }
                case 7: { 
                    if (stack.popBoolean()) {
                        state = 12; 
                    } else {
                        state = 6; //   .
                    }
                    break;
                }
                case 8: { 
                    state = 7; 
                    break;
                }
                case 9: { //     
                    state = 8; 
                    break;
                }
                case 10: { //      ()
                    if (stack.popBoolean()) {
                        state = 11; // ,   
                    } else {
                        state = 9; //     
                    }
                    break;
                }
                case 11: { // ,   
                    state = 9; //     
                    break;
                }
                case 12: { 
                    state = 10; //      ()
                    break;
                }
                case 13: { 
                    state = 7; 
                    break;
                }
                case 14: { //      
                    state = 3; //       ,       .
                    break;
                }
                case 15: { // IfDinizNetworkExist
                    state = 14; //      
                    break;
                }
                case 16: { // IfDinizNetworkExist ()
                    if (stack.popBoolean()) {
                        state = 19; //   
                    } else {
                        state = 15; // IfDinizNetworkExist
                    }
                    break;
                }
                case 17: { // LastLayerBuilt
                    state = 15; // IfDinizNetworkExist
                    break;
                }
                case 18: { //   
                    state = 17; // LastLayerBuilt
                    break;
                }
                case 19: { //   
                    state = 18; //   
                    break;
                }
                case 20: { //   
                    state = 16; // IfDinizNetworkExist ()
                    break;
                }
                case END_STATE: { //  
                    state = 20; //   
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case 1: { //  
                    comment = DMKM.this.getComment("MakeNetwork.init"); 
                    break;
                }
                case 2: { 
                    comment = DMKM.this.getComment("MakeNetwork.Layer"); 
                    break;
                }
                case 11: { // ,   
                    comment = DMKM.this.getComment("MakeNetwork.ArcExist"); 
                    args = new Object[]{new Character(d.si), new Character(d.sj), new Integer(d.dst[d.i]), new Integer(d.dst[d.j]), new Integer(d.n - 1)}; 
                    break;
                }
                case 17: { // LastLayerBuilt
                    comment = DMKM.this.getComment("MakeNetwork.LastLayerBuilt"); 
                    break;
                }
                case 18: { //   
                    comment = DMKM.this.getComment("MakeNetwork.MakeNetworkBigStep"); 
                    args = new Object[]{new Integer(d.dst[d.t])}; 
                    break;
                }
                case 19: { //   
                    comment = DMKM.this.getComment("MakeNetwork.StartPseudomax"); 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case 1: { //  
                    d.vis.showDiniz(false);
                    break;
                }
                case 2: { 
                    d.vis.showDiniz(false);
                    break;
                }
                case 11: { // ,   
                    d.vis.showDiniz(false);
                    break;
                }
                case 17: { // LastLayerBuilt
                    d.vis.showDiniz(false);
                    break;
                }
                case 18: { //   
                    d.vis.showDiniz(false);
                    break;
                }
                case 19: { //   
                    d.vis.showDiniz(false);
                    break;
                }
            }
        }
    }

    /**
      *      .
      */
    private final class GetPotentials extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 2;

        /**
          * .
          */
        public GetPotentials() {
            super( 
                "GetPotentials", 
                0, //    
                2, //    
                new String[]{ 
                    " ",  
                    "     .", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    1, //      . 
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; //      .
                    break;
                }
                case 1: { //      .
                    state = END_STATE; 
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //      .
                    int i;
                    for (i = 0; i < d.n; i++) stack.pushInteger(d.p[i]);
                    for (i = 0; i < d.n; i++) stack.pushInteger(d.pin[i]);
                    for (i = 0; i < d.n; i++) stack.pushInteger(d.pout[i]);
                    for (i = 0; i < d.n; i++) stack.pushInteger(d.dq[i]);
                    stack.pushInteger(d.dpw);
                    
                    int j;
                    for (i = 0; i < d.n; i++) d.p[i] = d.pin[i] = d.pout[i] = 0;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            if (d.dg[i][j] > 0){
                                d.pin[j] += d.dg[i][j];
                                d.pout[i] += d.dg[i][j];
                            }
                    d.pin[d.s] = d.pout[d.t] = d.maxint;
                    for (i = 0; i < d.n; i++) {
                        if (d.pin[i] < d.pout[i]) d.p[i] = d.pin[i]; else d.p[i] = d.pout[i];
                        if (d.p[i] == 0 && !d.del[i]) d.dq[d.dpw++] = i;
                    }
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { //      .
                    int i;
                    d.dpw = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--) d.dq[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--) d.pout[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--) d.pin[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--) d.p[i] = stack.popInteger();
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //      .
                    state = START_STATE; 
                    break;
                }
                case END_STATE: { //  
                    state = 1; //      .
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case 1: { //      .
                    comment = DMKM.this.getComment("GetPotentials.GetPotentials"); 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case 1: { //      .
                    d.vis.showPotentials();
                    break;
                }
            }
        }
    }

    /**
      *     .
      */
    private final class DeleteZero extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 7;

        /**
          * .
          */
        public DeleteZero() {
            super( 
                "DeleteZero", 
                0, //    
                7, //    
                new String[]{ 
                    " ",  
                    "    .", 
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    -1, //     . 
                    -1, //  
                    0, //  
                    -1, //  
                    0, //  
                    -1, //  
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; //     .
                    break;
                }
                case 1: { //     .
                    stack.pushBoolean(false); 
                    state = 2; 
                    break;
                }
                case 2: { 
                    if (d.dpr < d.dpw) {
                        state = 3; 
                    } else {
                        state = 6; 
                    }
                    break;
                }
                case 3: { 
                    state = 4; 
                    break;
                }
                case 4: { 
                    state = 5; 
                    break;
                }
                case 5: { 
                    stack.pushBoolean(true); 
                    state = 2; 
                    break;
                }
                case 6: { 
                    state = END_STATE; 
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //     .
                    stack.pushInteger(d.dpr);
                    
                    d.dpr = 0;
                    break;
                }
                case 2: { 
                    break;
                }
                case 3: { 
                    stack.pushCharacter(d.si);
                    stack.pushInteger(d.i);
                    stack.pushInteger(d.j);
                    for (int i = 0; i < d.n; i++)
                        stack.pushBoolean(d.del[i]);
                    
                    d.i = d.dq[d.dpr++];
                    
                    if (d.i == 0) d.si = 's';
                    else if (d.i == d.n - 1) d.si = 't';
                    else d.si = (char)(d.i + 48);
                    
                    d.del[d.i] = true;
                    d.j = 0;
                    break;
                }
                case 4: { 
                    int i;
                    stack.pushInteger(d.dpw);
                    for (i = 0; i < d.n; i++) stack.pushInteger(d.dq[i]);
                    for (i = 0; i < d.n; i++) stack.pushInteger(d.p[i]);
                    for (i = 0; i < d.n; i++) stack.pushInteger(d.pin[i]);
                    for (i = 0; i < d.n; i++) stack.pushInteger(d.pout[i]);
                    
                    int min;
                    for (int j = 0; j < d.n; j++) if (d.p[j] != 0){
                        if (d.dg[d.i][j] > 0){
                            d.pout[d.i] -= (d.dg[d.i][j] - d.df[d.i][j]);
                            d.pin[j] -= (d.dg[d.i][j] - d.df[d.i][j]);
                        }
                        if (d.dg[j][d.i] > 0){
                            d.pout[j] -= (d.dg[j][d.i] - d.df[j][d.i]);
                            d.pin[d.i] -= (d.dg[j][d.i] - d.df[j][d.i]);
                        }
                        if (d.pin[d.i] < d.pout[d.i]) min = d.pin[d.i]; else min = d.pout[d.i];
                        if (d.p[d.i] > min) d.p[d.i] = min;
                        if (d.pin[j] < d.pout[j]) min = d.pin[j]; else min = d.pout[j];
                        if (d.p[j] > min) d.p[j] = min;
                        if (d.p[j] == 0) d.dq[d.dpw++] = j;
                    }
                    break;
                }
                case 5: { 
                    break;
                }
                case 6: { 
                    stack.pushBoolean(d.isDel);
                    stack.pushInteger(d.dpw);
                    d.isDel = true;
                    for (int i = 0; i < d.n; i++)
                        if (!d.del[i]) d.isDel = false;
                    d.dpw = 0;
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { //     .
                    d.dpr = stack.popInteger();
                    break;
                }
                case 2: { 
                    break;
                }
                case 3: { 
                    d.dpr--;
                         for (int i = d.n - 1; i >= 0; i--)
                             d.del[i] = stack.popBoolean();
                         d.j = stack.popInteger();
                         d.i = stack.popInteger();
                         d.si = stack.popCharacter();
                    break;
                }
                case 4: { 
                    int i;
                    for (i = d.n - 1; i >= 0; i--) d.pout[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--) d.pin[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--) d.p[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--) d.dq[i] = stack.popInteger();
                    d.dpw = stack.popInteger();
                    break;
                }
                case 5: { 
                    break;
                }
                case 6: { 
                    d.dpw = stack.popInteger();
                    d.isDel = stack.popBoolean();
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //     .
                    state = START_STATE; 
                    break;
                }
                case 2: { 
                    if (stack.popBoolean()) {
                        state = 5; 
                    } else {
                        state = 1; //     .
                    }
                    break;
                }
                case 3: { 
                    state = 2; 
                    break;
                }
                case 4: { 
                    state = 3; 
                    break;
                }
                case 5: { 
                    state = 4; 
                    break;
                }
                case 6: { 
                    state = 2; 
                    break;
                }
                case END_STATE: { //  
                    state = 6; 
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case 3: { 
                    comment = DMKM.this.getComment("DeleteZero.DeleteStep"); 
                    args = new Object[]{new Character(d.si)}; 
                    break;
                }
                case 5: { 
                    comment = DMKM.this.getComment("DeleteZero.UpdatePotentials"); 
                    args = new Object[]{new Integer(d.i)}; 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case 3: { 
                    d.vis.showDelete(!d.isFirstDelete);
                    break;
                }
                case 5: { 
                    d.vis.showDelete(!d.isFirstDelete);
                    break;
                }
            }
        }
    }

    /**
      *     .
      */
    private final class GetMinv extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 3;

        /**
          * .
          */
        public GetMinv() {
            super( 
                "GetMinv", 
                0, //    
                3, //    
                new String[]{ 
                    " ",  
                    "    .", 
                    "        ", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    1, //     . 
                    -1, //          
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; //     .
                    break;
                }
                case 1: { //     .
                    state = 2; //         
                    break;
                }
                case 2: { //         
                    state = END_STATE; 
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //     .
                    stack.pushCharacter(d.sj);
                    stack.pushInteger(d.minv);
                    stack.pushInteger(d.minp);
                    
                    if (d.minv == 0) d.sj = 's';
                    else if (d.minv == d.n - 1) d.sj = 't';
                    else d.sj = (char)(d.minv + 48);
                    
                    d.minv = d.s;
                    for (int i = 0; i < d.n; i++)
                        if ( (d.p[i] != 0) && (d.p[d.minv] > d.p[i]) ) d.minv = i;
                    d.minp = d.p[d.minv];
                    break;
                }
                case 2: { //         
                    stack.pushBoolean(d.isFirstGetMinv);
                    d.isFirstGetMinv = false;
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { //     .
                    d.minp = stack.popInteger();
                    d.minv = stack.popInteger();
                    d.sj = stack.popCharacter();
                    break;
                }
                case 2: { //         
                    d.isFirstGetMinv = stack.popBoolean();
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //     .
                    state = START_STATE; 
                    break;
                }
                case 2: { //         
                    state = 1; //     .
                    break;
                }
                case END_STATE: { //  
                    state = 2; //         
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case 1: { //     .
                    comment = DMKM.this.getComment("GetMinv.GetMinv"); 
                    args = new Object[]{new Character(d.sj), new Integer(d.p[d.minv])}; 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case 1: { //     .
                    d.vis.showMinv(!d.isFirstGetMinv);
                    break;
                }
            }
        }
    }

    /**
      *       .
      */
    private final class Forward extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 15;

        /**
          * .
          */
        public Forward() {
            super( 
                "Forward", 
                0, //    
                15, //    
                new String[]{ 
                    " ",  
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    " ()", 
                    "", 
                    "", 
                    " ()", 
                    "", 
                    "", 
                    "", 
                    "      ", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    1, //  
                    -1, //  
                    -1, //  
                    -1, //  
                    -1, //  
                    -1, //  
                    -1, //  () 
                    -1, //  
                    -1, //  
                    -1, //  () 
                    0, //  
                    -1, //  
                    -1, //  
                    1, //        
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; // 
                    break;
                }
                case 1: { // 
                    stack.pushBoolean(false); 
                    state = 2; 
                    break;
                }
                case 2: { 
                    if (d.pr < d.pw) {
                        state = 3; 
                    } else {
                        state = 13; 
                    }
                    break;
                }
                case 3: { 
                    state = 4; 
                    break;
                }
                case 4: { 
                    stack.pushBoolean(false); 
                    state = 5; 
                    break;
                }
                case 5: { 
                    if (d.j < d.n) {
                        state = 6; 
                    } else {
                        stack.pushBoolean(true); 
                        state = 2; 
                    }
                    break;
                }
                case 6: { 
                    if (d.p[d.j] > 0) {
                        state = 8; 
                    } else {
                        stack.pushBoolean(false); 
                        state = 7; //  ()
                    }
                    break;
                }
                case 7: { //  ()
                    state = 12; 
                    break;
                }
                case 8: { 
                    state = 9; 
                    break;
                }
                case 9: { 
                    if (d.delta > 0) {
                        state = 11; 
                    } else {
                        stack.pushBoolean(false); 
                        state = 10; //  ()
                    }
                    break;
                }
                case 10: { //  ()
                    stack.pushBoolean(true); 
                    state = 7; //  ()
                    break;
                }
                case 11: { 
                    stack.pushBoolean(true); 
                    state = 10; //  ()
                    break;
                }
                case 12: { 
                    stack.pushBoolean(true); 
                    state = 5; 
                    break;
                }
                case 13: { 
                    state = 14; //       
                    break;
                }
                case 14: { //       
                    state = END_STATE; 
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { // 
                    stack.pushCharacter(d.sj);
                    int i, j;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushBoolean(d.newArc[i][j]);
                    for (i = 0; i < d.n; i++)
                        stack.pushInteger(d.fl[i]);
                    stack.pushInteger(d.pr);
                    stack.pushInteger(d.pw);
                    stack.pushInteger(d.q[0]);
                    
                    if (d.minv == 0) d.sj = 's';
                    else if (d.minv == d.n - 1) d.sj= 't';
                    else d.sj = (char)(d.minv + 48);
                    
                    for (i = 0; i < d.n; i++)
                        d.fl[i] = 0;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            d.newArc[i][j] = false;
                    d.fl[d.minv] = d.p[d.minv];
                    d.pr = 0; d.pw = 1; d.q[0] = d.minv;
                    break;
                }
                case 2: { 
                    break;
                }
                case 3: { 
                    stack.pushInteger(d.i);
                    d.i = d.q[d.pr++];
                    break;
                }
                case 4: { 
                    stack.pushInteger(d.j);
                    d.j = 0;
                    break;
                }
                case 5: { 
                    break;
                }
                case 6: { 
                    break;
                }
                case 7: { //  ()
                    break;
                }
                case 8: { 
                    stack.pushInteger(d.delta);
                    if (d.fl[d.i] < d.dg[d.i][d.j] - d.df[d.i][d.j]) d.delta = d.fl[d.i]; else d.delta = d.dg[d.i][d.j] - d.df[d.i][d.j];
                    break;
                }
                case 9: { 
                    break;
                }
                case 10: { //  ()
                    break;
                }
                case 11: { 
                    stack.pushCharacter(d.si);
                    stack.pushCharacter(d.sj);
                    stack.pushBoolean(d.newArc[d.i][d.j]);
                    stack.pushInteger(d.q[d.pw]);
                    stack.pushInteger(d.p[d.j]);
                    stack.pushInteger(d.p[d.i]);
                    stack.pushInteger(d.f[d.j][d.i]);
                    stack.pushInteger(d.f[d.i][d.j]);
                    stack.pushInteger(d.dpw);
                    for (int i = 0; i < d.n; i++)
                        stack.pushInteger(d.dq[i]);
                    
                    if (d.i == 0) d.si = 's';
                    else if (d.i == d.n - 1) d.si = 't';
                    else d.si = (char)(d.i + 48);
                    if (d.j == 0) d.sj = 's';
                    else if (d.j == d.n - 1) d.sj = 't';
                    else d.sj = (char)(d.j + 48);
                    
                    d.pin[d.j] -= d.delta;
                    d.pout[d.i] -= d.delta;
                    if (d.p[d.i] > d.pout[d.i]) {
                        if (d.pout[d.i] == 0) d.dq[d.dpw++] = d.i;
                        d.p[d.i] = d.pout[d.i];
                    }
                    if (d.p[d.j] > d.pin[d.j]) {
                        if (d.pin[d.j] == 0) d.dq[d.dpw++] = d.j;
                        d.p[d.j] = d.pin[d.j];
                    }
                    d.df[d.i][d.j] += d.delta;
                    d.newArc[d.i][d.j] = true;
                    d.fl[d.i] -= d.delta;
                    d.fl[d.j] += d.delta;
                    d.q[d.pw++] = d.j;
                    
                    if (d.g[d.i][d.j] > 0) d.f[d.i][d.j] += d.delta;
                    else if (d.g[d.j][d.i] > 0) d.f[d.j][d.i] -= d.delta;
                    break;
                }
                case 12: { 
                    d.j++;
                    break;
                }
                case 13: { 
                    int i, j;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushBoolean(d.newFlowArc[i][j]);
                    
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            d.newFlowArc[i][j] = d.newFlowArc[i][j] | d.newArc[i][j];
                    break;
                }
                case 14: { //       
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { // 
                    int i, j;
                    d.q[0] = stack.popInteger();
                    d.pw = stack.popInteger();
                    d.pr = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        d.fl[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.newArc[i][j] = stack.popBoolean();
                    d.sj = stack.popCharacter();
                    break;
                }
                case 2: { 
                    break;
                }
                case 3: { 
                    d.pr--;
                    d.i = stack.popInteger();
                    break;
                }
                case 4: { 
                    d.j = stack.popInteger();
                    break;
                }
                case 5: { 
                    break;
                }
                case 6: { 
                    break;
                }
                case 7: { //  ()
                    break;
                }
                case 8: { 
                    d.delta = stack.popInteger();
                    break;
                }
                case 9: { 
                    break;
                }
                case 10: { //  ()
                    break;
                }
                case 11: { 
                    for (int i = d.n - 1; i >= 0; i--)
                        d.dq[i] = stack.popInteger();
                    d.dpw = stack.popInteger();
                    d.f[d.i][d.j] = stack.popInteger();
                    d.f[d.j][d.i] = stack.popInteger();
                    d.p[d.i] = stack.popInteger();
                    d.p[d.j] = stack.popInteger();
                    d.pin[d.j] += d.delta;
                    d.pout[d.i] += d.delta;
                    d.df[d.i][d.j] -= d.delta;
                    d.fl[d.i] += d.delta;
                    d.fl[d.j] -= d.delta;
                    d.pw--;
                    d.q[d.pw] = stack.popInteger();
                    d.newArc[d.i][d.j] = stack.popBoolean();
                    d.sj = stack.popCharacter();
                    d.si = stack.popCharacter();
                    break;
                }
                case 12: { 
                    d.j--;
                    break;
                }
                case 13: { 
                    int i, j;
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.newFlowArc[i][j] = stack.popBoolean();
                    break;
                }
                case 14: { //       
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { // 
                    state = START_STATE; 
                    break;
                }
                case 2: { 
                    if (stack.popBoolean()) {
                        state = 5; 
                    } else {
                        state = 1; // 
                    }
                    break;
                }
                case 3: { 
                    state = 2; 
                    break;
                }
                case 4: { 
                    state = 3; 
                    break;
                }
                case 5: { 
                    if (stack.popBoolean()) {
                        state = 12; 
                    } else {
                        state = 4; 
                    }
                    break;
                }
                case 6: { 
                    state = 5; 
                    break;
                }
                case 7: { //  ()
                    if (stack.popBoolean()) {
                        state = 10; //  ()
                    } else {
                        state = 6; 
                    }
                    break;
                }
                case 8: { 
                    state = 6; 
                    break;
                }
                case 9: { 
                    state = 8; 
                    break;
                }
                case 10: { //  ()
                    if (stack.popBoolean()) {
                        state = 11; 
                    } else {
                        state = 9; 
                    }
                    break;
                }
                case 11: { 
                    state = 9; 
                    break;
                }
                case 12: { 
                    state = 7; //  ()
                    break;
                }
                case 13: { 
                    state = 2; 
                    break;
                }
                case 14: { //       
                    state = 13; 
                    break;
                }
                case END_STATE: { //  
                    state = 14; //       
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case 1: { // 
                    comment = DMKM.this.getComment("Forward.forward"); 
                    args = new Object[]{new Integer(d.minp), new Character(d.sj)}; 
                    break;
                }
                case 11: { 
                    comment = DMKM.this.getComment("Forward.throw"); 
                    args = new Object[]{new Integer(d.delta), new Character(d.si), new Character(d.sj)}; 
                    break;
                }
                case 14: { //       
                    comment = DMKM.this.getComment("Forward.EndForward"); 
                    args = new Object[]{new Integer(d.minp)}; 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case 1: { // 
                    d.vis.showForward();
                    break;
                }
                case 11: { 
                    d.vis.showForward();
                    break;
                }
                case 14: { //       
                    d.vis.showForward();
                    break;
                }
            }
        }
    }

    /**
      *       .
      */
    private final class Backward extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 15;

        /**
          * .
          */
        public Backward() {
            super( 
                "Backward", 
                0, //    
                15, //    
                new String[]{ 
                    " ",  
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    " ()", 
                    "", 
                    "", 
                    " ()", 
                    "", 
                    "", 
                    "", 
                    "      ", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    1, //  
                    -1, //  
                    -1, //  
                    -1, //  
                    -1, //  
                    -1, //  
                    -1, //  () 
                    -1, //  
                    -1, //  
                    -1, //  () 
                    0, //  
                    -1, //  
                    -1, //  
                    1, //        
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; // 
                    break;
                }
                case 1: { // 
                    stack.pushBoolean(false); 
                    state = 2; 
                    break;
                }
                case 2: { 
                    if (d.pr < d.pw) {
                        state = 3; 
                    } else {
                        state = 13; 
                    }
                    break;
                }
                case 3: { 
                    state = 4; 
                    break;
                }
                case 4: { 
                    stack.pushBoolean(false); 
                    state = 5; 
                    break;
                }
                case 5: { 
                    if (d.j < d.n) {
                        state = 6; 
                    } else {
                        stack.pushBoolean(true); 
                        state = 2; 
                    }
                    break;
                }
                case 6: { 
                    if (d.p[d.j] > 0) {
                        state = 8; 
                    } else {
                        stack.pushBoolean(false); 
                        state = 7; //  ()
                    }
                    break;
                }
                case 7: { //  ()
                    state = 12; 
                    break;
                }
                case 8: { 
                    state = 9; 
                    break;
                }
                case 9: { 
                    if (d.delta > 0) {
                        state = 11; 
                    } else {
                        stack.pushBoolean(false); 
                        state = 10; //  ()
                    }
                    break;
                }
                case 10: { //  ()
                    stack.pushBoolean(true); 
                    state = 7; //  ()
                    break;
                }
                case 11: { 
                    stack.pushBoolean(true); 
                    state = 10; //  ()
                    break;
                }
                case 12: { 
                    stack.pushBoolean(true); 
                    state = 5; 
                    break;
                }
                case 13: { 
                    state = 14; //       
                    break;
                }
                case 14: { //       
                    state = END_STATE; 
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { // 
                    stack.pushCharacter(d.si);
                    int i, j;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushBoolean(d.newArc[i][j]);
                    for (i = 0; i < d.n; i++)
                        stack.pushInteger(d.fl[i]);
                    stack.pushInteger(d.pr);
                    stack.pushInteger(d.pw);
                    stack.pushInteger(d.q[0]);
                    
                    if (d.minv == 0) d.si = 's';
                    else if (d.minv == d.n - 1) d.si = 't';
                    else d.si = (char)(d.minv + 48);
                    
                    for (i = 0; i < d.n; i++)
                        d.fl[i] = 0;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            d.newArc[i][j] = false;
                    d.fl[d.minv] = d.minp;
                    d.pr = 0; d.pw = 1; d.q[0] = d.minv;
                    break;
                }
                case 2: { 
                    break;
                }
                case 3: { 
                    stack.pushInteger(d.i);
                    d.i = d.q[d.pr++];
                    break;
                }
                case 4: { 
                    stack.pushInteger(d.j);
                    d.j = 0;
                    break;
                }
                case 5: { 
                    break;
                }
                case 6: { 
                    break;
                }
                case 7: { //  ()
                    break;
                }
                case 8: { 
                    stack.pushInteger(d.delta);
                    if (d.fl[d.i] < d.dg[d.j][d.i] - d.df[d.j][d.i]) d.delta = d.fl[d.i]; else d.delta = d.dg[d.j][d.i] - d.df[d.j][d.i];
                    break;
                }
                case 9: { 
                    break;
                }
                case 10: { //  ()
                    break;
                }
                case 11: { 
                    stack.pushCharacter(d.si);
                    stack.pushCharacter(d.sj);
                    stack.pushBoolean(d.newArc[d.j][d.i]);
                    stack.pushInteger(d.q[d.pw]);
                    stack.pushInteger(d.p[d.i]);
                    stack.pushInteger(d.p[d.j]);
                    stack.pushInteger(d.df[d.i][d.j]);
                    stack.pushInteger(d.df[d.j][d.i]);
                    stack.pushInteger(d.dpw);
                    for (int i = 0; i < d.n; i++)
                        stack.pushInteger(d.dq[i]);
                    
                    if (d.i == 0) d.si = 's';
                    else if (d.i == d.n - 1) d.si = 't';
                    else d.si = (char)(d.i + 48);
                    if (d.j == 0) d.sj = 's';
                    else if (d.j == d.n - 1) d.sj = 't';
                    else d.sj = (char)(d.j + 48);
                    
                    d.pin[d.i] -= d.delta;
                    d.pout[d.j] -= d.delta;
                    if (d.p[d.i] > d.pin[d.i]) {
                        if (d.pin[d.i] == 0) d.dq[d.dpw++] = d.i;
                        d.p[d.i] = d.pin[d.i];
                    }
                    if (d.p[d.j] > d.pout[d.j]) {
                        if (d.pout[d.j] == 0) d.dq[d.dpw++] = d.j;
                        d.p[d.j] = d.pout[d.j];
                    }
                    d.df[d.j][d.i] += d.delta;
                    d.newArc[d.j][d.i] = true;
                    d.fl[d.i] -= d.delta;
                    d.fl[d.j] += d.delta;
                    d.q[d.pw++] = d.j;
                    
                    if (d.g[d.j][d.i] > 0) d.f[d.j][d.i] += d.delta;
                    else if (d.g[d.i][d.j] > 0) d.f[d.i][d.j] -= d.delta;
                    break;
                }
                case 12: { 
                    d.j++;
                    break;
                }
                case 13: { 
                    int i, j;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushBoolean(d.newFlowArc[i][j]);
                    
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            d.newFlowArc[i][j] = d.newFlowArc[i][j] | d.newArc[i][j];
                    break;
                }
                case 14: { //       
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { // 
                    int i, j;
                    d.q[0] = stack.popInteger();
                    d.pw = stack.popInteger();
                    d.pr = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        d.fl[i] = stack.popInteger();
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.newArc[i][j] = stack.popBoolean();
                    d.si = stack.popCharacter();
                    break;
                }
                case 2: { 
                    break;
                }
                case 3: { 
                    d.pr--;
                    d.i = stack.popInteger();
                    break;
                }
                case 4: { 
                    d.j = stack.popInteger();
                    break;
                }
                case 5: { 
                    break;
                }
                case 6: { 
                    break;
                }
                case 7: { //  ()
                    break;
                }
                case 8: { 
                    d.delta = stack.popInteger();
                    break;
                }
                case 9: { 
                    break;
                }
                case 10: { //  ()
                    break;
                }
                case 11: { 
                    for (int i = d.n - 1; i >= 0; i--)
                        d.dq[i] = stack.popInteger();
                    d.dpw = stack.popInteger();
                    d.f[d.j][d.i] = stack.popInteger();
                    d.f[d.i][d.j] = stack.popInteger();
                    d.p[d.j] = stack.popInteger();
                    d.p[d.i] = stack.popInteger();
                    d.pin[d.i] += d.delta;
                    d.pout[d.j] += d.delta;
                    d.df[d.j][d.i] -= d.delta;
                    d.fl[d.i] += d.delta;
                    d.fl[d.j] -= d.delta;
                    d.pw--;
                    d.q[d.pw] = stack.popInteger();
                    d.newArc[d.j][d.i] = stack.popBoolean();
                    d.sj = stack.popCharacter();
                    d.si = stack.popCharacter();
                    break;
                }
                case 12: { 
                    d.j--;
                    break;
                }
                case 13: { 
                    int i, j;
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.newFlowArc[i][j] = stack.popBoolean();
                    break;
                }
                case 14: { //       
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { // 
                    state = START_STATE; 
                    break;
                }
                case 2: { 
                    if (stack.popBoolean()) {
                        state = 5; 
                    } else {
                        state = 1; // 
                    }
                    break;
                }
                case 3: { 
                    state = 2; 
                    break;
                }
                case 4: { 
                    state = 3; 
                    break;
                }
                case 5: { 
                    if (stack.popBoolean()) {
                        state = 12; 
                    } else {
                        state = 4; 
                    }
                    break;
                }
                case 6: { 
                    state = 5; 
                    break;
                }
                case 7: { //  ()
                    if (stack.popBoolean()) {
                        state = 10; //  ()
                    } else {
                        state = 6; 
                    }
                    break;
                }
                case 8: { 
                    state = 6; 
                    break;
                }
                case 9: { 
                    state = 8; 
                    break;
                }
                case 10: { //  ()
                    if (stack.popBoolean()) {
                        state = 11; 
                    } else {
                        state = 9; 
                    }
                    break;
                }
                case 11: { 
                    state = 9; 
                    break;
                }
                case 12: { 
                    state = 7; //  ()
                    break;
                }
                case 13: { 
                    state = 2; 
                    break;
                }
                case 14: { //       
                    state = 13; 
                    break;
                }
                case END_STATE: { //  
                    state = 14; //       
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case 1: { // 
                    comment = DMKM.this.getComment("Backward.BackwardInit"); 
                    args = new Object[]{new Integer(d.minp), new Character(d.si)}; 
                    break;
                }
                case 11: { 
                    comment = DMKM.this.getComment("Backward.throw"); 
                    args = new Object[]{new Integer(d.delta), new Character(d.si), new Character(d.sj)}; 
                    break;
                }
                case 14: { //       
                    comment = DMKM.this.getComment("Backward.forward"); 
                    args = new Object[]{new Integer(d.minp)}; 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case 1: { // 
                    d.vis.showBackward();
                    break;
                }
                case 11: { 
                    d.vis.showForward();
                    break;
                }
                case 14: { //       
                    d.vis.showBackward();
                    break;
                }
            }
        }
    }

    /**
      *      .
      */
    private final class MakeFlow extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 14;

        /**
          * .
          */
        public MakeFlow() {
            super( 
                "MakeFlow", 
                0, //    
                14, //    
                new String[]{ 
                    " ",  
                    "   ", 
                    "    .    .", 
                    "     ()", 
                    "", 
                    "     ,     ", 
                    "     ()", 
                    "       ()", 
                    "       ()", 
                    "delete_zero_after_flow", 
                    "     ()", 
                    "", 
                    "", 
                    "     .", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    -1, //     
                    1, //     .    . 
                    0, //      () 
                    1, //  
                    -1, //      ,      
                    0, //      () 
                    0, //        () 
                    0, //        () 
                    1, // delete_zero_after_flow 
                    0, //      () 
                    1, //  
                    0, //  
                    1, //      . 
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; //    
                    break;
                }
                case 1: { //    
                    state = 2; //     .    .
                    break;
                }
                case 2: { //     .    .
                    state = 3; //      ()
                    break;
                }
                case 3: { //      ()
                    if (child.isAtEnd()) {
                        child = null; 
                        state = 4; 
                    }
                    break;
                }
                case 4: { 
                    stack.pushBoolean(false); 
                    state = 5; //      ,     
                    break;
                }
                case 5: { //      ,     
                    if (!d.isDel) {
                        state = 6; //      ()
                    } else {
                        state = 12; 
                    }
                    break;
                }
                case 6: { //      ()
                    if (child.isAtEnd()) {
                        child = null; 
                        state = 7; //        ()
                    }
                    break;
                }
                case 7: { //        ()
                    if (child.isAtEnd()) {
                        child = null; 
                        state = 8; //        ()
                    }
                    break;
                }
                case 8: { //        ()
                    if (child.isAtEnd()) {
                        child = null; 
                        state = 9; // delete_zero_after_flow
                    }
                    break;
                }
                case 9: { // delete_zero_after_flow
                    state = 10; //      ()
                    break;
                }
                case 10: { //      ()
                    if (child.isAtEnd()) {
                        child = null; 
                        state = 11; 
                    }
                    break;
                }
                case 11: { 
                    stack.pushBoolean(true); 
                    state = 5; //      ,     
                    break;
                }
                case 12: { 
                    state = 13; //      .
                    break;
                }
                case 13: { //      .
                    state = END_STATE; 
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //    
                    int i, j;
                    stack.pushBoolean(d.isDel);
                    stack.pushBoolean(d.isFirstGetMinv);
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushBoolean(d.newFlowArc[i][j]);
                    
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            d.newFlowArc[i][j] = false;
                    d.isDel = false;
                    d.isFirstGetMinv = true;
                    break;
                }
                case 2: { //     .    .
                    stack.pushBoolean(d.isFirstDelete);
                    d.isFirstDelete = true;
                    break;
                }
                case 3: { //      ()
                    if (child == null) {
                        child = new DeleteZero(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 4: { 
                    break;
                }
                case 5: { //      ,     
                    break;
                }
                case 6: { //      ()
                    if (child == null) {
                        child = new GetMinv(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 7: { //        ()
                    if (child == null) {
                        child = new Forward(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 8: { //        ()
                    if (child == null) {
                        child = new Backward(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 9: { // delete_zero_after_flow
                    stack.pushBoolean(d.isFirstDelete);
                    d.isFirstDelete = false;
                    break;
                }
                case 10: { //      ()
                    if (child == null) {
                        child = new DeleteZero(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 11: { 
                    break;
                }
                case 12: { 
                    break;
                }
                case 13: { //      .
                    int i;
                    for (i = 0; i < d.n; i++)
                        stack.pushBoolean(d.del[i]);
                    stack.pushInteger(d.pseudoResultFlow);
                    
                    for (i = 0; i < d.n; i++)
                        d.del[i] = d.diniz[i];
                    d.pseudoResultFlow = 0;
                    for (i = 0; i < d.n; i++)
                        d.pseudoResultFlow += d.df[0][i];
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { //    
                    int i, j;
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.newFlowArc[i][j] = stack.popBoolean();
                    d.isFirstGetMinv = stack.popBoolean();
                    d.isDel = stack.popBoolean();
                    break;
                }
                case 2: { //     .    .
                    d.isFirstDelete = stack.popBoolean();
                    break;
                }
                case 3: { //      ()
                    if (child == null) {
                        child = new DeleteZero(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 4: { 
                    break;
                }
                case 5: { //      ,     
                    break;
                }
                case 6: { //      ()
                    if (child == null) {
                        child = new GetMinv(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 7: { //        ()
                    if (child == null) {
                        child = new Forward(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 8: { //        ()
                    if (child == null) {
                        child = new Backward(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 9: { // delete_zero_after_flow
                    d.isFirstDelete = stack.popBoolean();
                    break;
                }
                case 10: { //      ()
                    if (child == null) {
                        child = new DeleteZero(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 11: { 
                    break;
                }
                case 12: { 
                    break;
                }
                case 13: { //      .
                    d.pseudoResultFlow = stack.popInteger();
                    for (int i = d.n - 1; i >= 0; i--)
                        d.del[i] = stack.popBoolean();
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //    
                    state = START_STATE; 
                    break;
                }
                case 2: { //     .    .
                    state = 1; //    
                    break;
                }
                case 3: { //      ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 2; //     .    .
                    }
                    break;
                }
                case 4: { 
                    state = 3; //      ()
                    break;
                }
                case 5: { //      ,     
                    if (stack.popBoolean()) {
                        state = 11; 
                    } else {
                        state = 4; 
                    }
                    break;
                }
                case 6: { //      ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 5; //      ,     
                    }
                    break;
                }
                case 7: { //        ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 6; //      ()
                    }
                    break;
                }
                case 8: { //        ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 7; //        ()
                    }
                    break;
                }
                case 9: { // delete_zero_after_flow
                    state = 8; //        ()
                    break;
                }
                case 10: { //      ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 9; // delete_zero_after_flow
                    }
                    break;
                }
                case 11: { 
                    state = 10; //      ()
                    break;
                }
                case 12: { 
                    state = 5; //      ,     
                    break;
                }
                case 13: { //      .
                    state = 12; 
                    break;
                }
                case END_STATE: { //  
                    state = 13; //      .
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case 2: { //     .    .
                    comment = DMKM.this.getComment("MakeFlow.FirstDeleteZero"); 
                    break;
                }
                case 3: { //      ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 4: { 
                    comment = DMKM.this.getComment("MakeFlow.FinishFirstDeleteZero"); 
                    break;
                }
                case 6: { //      ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 7: { //        ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 8: { //        ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 9: { // delete_zero_after_flow
                    comment = DMKM.this.getComment("MakeFlow.DeleteZeroAfterFlow"); 
                    break;
                }
                case 10: { //      ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 11: { 
                    comment = DMKM.this.getComment("MakeFlow.FinishDeleteZero"); 
                    break;
                }
                case 12: { 
                    comment = DMKM.this.getComment("MakeFlow.EndPhase"); 
                    break;
                }
                case 13: { //      .
                    comment = DMKM.this.getComment("MakeFlow.EndDinizStep"); 
                    args = new Object[]{new Integer(d.pseudoResultFlow)}; 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case 2: { //     .    .
                    d.vis.showPotentials();
                    break;
                }
                case 3: { //      ()
                    child.drawState(); 
                    break;
                }
                case 4: { 
                    d.vis.showDelete(false);
                    break;
                }
                case 6: { //      ()
                    child.drawState(); 
                    break;
                }
                case 7: { //        ()
                    child.drawState(); 
                    break;
                }
                case 8: { //        ()
                    child.drawState(); 
                    break;
                }
                case 9: { // delete_zero_after_flow
                    d.vis.showDelete(true);
                    break;
                }
                case 10: { //      ()
                    child.drawState(); 
                    break;
                }
                case 11: { 
                    d.vis.showDelete(true);
                    break;
                }
                case 12: { 
                    d.vis.showDelete(true);
                    break;
                }
                case 13: { //      .
                    d.vis.showDiniz(true);
                    break;
                }
            }
        }
    }

    /**
      *   ,   -   .
      */
    private final class UpdateFlow extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 2;

        /**
          * .
          */
        public UpdateFlow() {
            super( 
                "UpdateFlow", 
                0, //    
                2, //    
                new String[]{ 
                    " ",  
                    "  ,   -   ", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    1, //   ,   -    
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; //   ,   -   
                    break;
                }
                case 1: { //   ,   -   
                    state = END_STATE; 
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //   ,   -   
                    int i, j;
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++)
                            stack.pushInteger(d.f[i][j]);
                    
                    for (i = 0; i < d.n; i++)
                        for (j = 0; j < d.n; j++){
                            //  
                        }
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { //   ,   -   
                    int i, j;
                    for (i = d.n - 1; i >= 0; i--)
                        for (j = d.n - 1; j >= 0; j--)
                            d.f[i][j] = stack.popInteger();
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //   ,   -   
                    state = START_STATE; 
                    break;
                }
                case END_STATE: { //  
                    state = 1; //   ,   -   
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case 1: { //   ,   -   
                    comment = DMKM.this.getComment("UpdateFlow.UpdateFlow"); 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case 1: { //   ,   -   
                    d.vis.showNetwork(true);
                    break;
                }
            }
        }
    }

    /**
      *  .
      */
    private final class Main extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 10;

        /**
          * .
          */
        public Main() {
            super( 
                "Main", 
                0, //    
                10, //    
                new String[]{ 
                    " ",  
                    "  .", 
                    "   ()", 
                    " ,      ", 
                    "      ()", 
                    "      ()", 
                    "  ,   -    ()", 
                    "   ()", 
                    "     .", 
                    "     .", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    -1, //   . 
                    0, //    () 
                    -1, //  ,       
                    0, //       () 
                    0, //       () 
                    0, //   ,   -    () 
                    0, //    () 
                    1, //      . 
                    -1, //      . 
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; //   .
                    break;
                }
                case 1: { //   .
                    state = 2; //    ()
                    break;
                }
                case 2: { //    ()
                    if (child.isAtEnd()) {
                        child = null; 
                        stack.pushBoolean(false); 
                        state = 3; //  ,      
                    }
                    break;
                }
                case 3: { //  ,      
                    if (d.isNetwork) {
                        state = 4; //       ()
                    } else {
                        state = 8; //      .
                    }
                    break;
                }
                case 4: { //       ()
                    if (child.isAtEnd()) {
                        child = null; 
                        state = 5; //       ()
                    }
                    break;
                }
                case 5: { //       ()
                    if (child.isAtEnd()) {
                        child = null; 
                        state = 6; //   ,   -    ()
                    }
                    break;
                }
                case 6: { //   ,   -    ()
                    if (child.isAtEnd()) {
                        child = null; 
                        state = 7; //    ()
                    }
                    break;
                }
                case 7: { //    ()
                    if (child.isAtEnd()) {
                        child = null; 
                        stack.pushBoolean(true); 
                        state = 3; //  ,      
                    }
                    break;
                }
                case 8: { //      .
                    state = 9; //      .
                    break;
                }
                case 9: { //      .
                    state = END_STATE; 
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //   .
                    int i, j;
                    int n = d.n;
                    d.t = d.n - 1;
                    for (i = 0; i < n; i++)
                        for (j = 0; j < n; j++) {
                            d.f[i][j] = 0;
                            d.dg[i][j] = 0;
                            d.df[i][j] = 0;
                            d.newArc[i][j] = false;
                            d.newFlowArc[i][j] = false;
                       }
                    for (i = 0; i < n; i++) {
                        d.dq = new int[n];
                        d.p[i] = 0;
                        d.pin[i] = 0;
                        d.pout[i] = 0;
                        d.del[i] = false;
                        d.dst[i] = 0;
                        d.q1[i] = 0;
                        d.q2[i] = 0;
                        d.q[i] = 0;
                        d.diniz[i] = false;
                        d.fl[i] = 0;
                        d.dq[i] = 0;
                    }
                    d.pr = 0;
                    d.pw = 0;
                    d.dpw = 0;
                    d.dpr = 0;
                    break;
                }
                case 2: { //    ()
                    if (child == null) {
                        child = new MakeNetwork(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 3: { //  ,      
                    break;
                }
                case 4: { //       ()
                    if (child == null) {
                        child = new GetPotentials(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 5: { //       ()
                    if (child == null) {
                        child = new MakeFlow(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 6: { //   ,   -    ()
                    if (child == null) {
                        child = new UpdateFlow(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 7: { //    ()
                    if (child == null) {
                        child = new MakeNetwork(); 
                        child.toStart(); 
                    }
                    child.stepForward(level); 
                    step--; 
                    break;
                }
                case 8: { //      .
                    break;
                }
                case 9: { //      .
                    stack.pushInteger(d.resultFlow);
                    d.resultFlow = 0;
                    for (int i = 0; i < d.n; i++)
                        d.resultFlow += d.f[0][i];
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { //   .
                    break;
                }
                case 2: { //    ()
                    if (child == null) {
                        child = new MakeNetwork(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 3: { //  ,      
                    break;
                }
                case 4: { //       ()
                    if (child == null) {
                        child = new GetPotentials(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 5: { //       ()
                    if (child == null) {
                        child = new MakeFlow(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 6: { //   ,   -    ()
                    if (child == null) {
                        child = new UpdateFlow(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 7: { //    ()
                    if (child == null) {
                        child = new MakeNetwork(); 
                        child.toEnd(); 
                    }
                    child.stepBackward(level); 
                    step++; 
                    break;
                }
                case 8: { //      .
                    break;
                }
                case 9: { //      .
                    d.resultFlow = stack.popInteger();
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { //   .
                    state = START_STATE; 
                    break;
                }
                case 2: { //    ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 1; //   .
                    }
                    break;
                }
                case 3: { //  ,      
                    if (stack.popBoolean()) {
                        state = 7; //    ()
                    } else {
                        state = 2; //    ()
                    }
                    break;
                }
                case 4: { //       ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 3; //  ,      
                    }
                    break;
                }
                case 5: { //       ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 4; //       ()
                    }
                    break;
                }
                case 6: { //   ,   -    ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 5; //       ()
                    }
                    break;
                }
                case 7: { //    ()
                    if (child.isAtStart()) {
                        child = null; 
                        state = 6; //   ,   -    ()
                    }
                    break;
                }
                case 8: { //      .
                    state = 3; //  ,      
                    break;
                }
                case 9: { //      .
                    state = 8; //      .
                    break;
                }
                case END_STATE: { //  
                    state = 9; //      .
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case START_STATE: { //  
                    comment = DMKM.this.getComment("Main.START_STATE"); 
                    break;
                }
                case 2: { //    ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 4: { //       ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 5: { //       ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 6: { //   ,   -    ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 7: { //    ()
                    comment = child.getComment(); 
                    args = new Object[0]; 
                    break;
                }
                case 8: { //      .
                    comment = DMKM.this.getComment("Main.NoPath"); 
                    break;
                }
                case END_STATE: { //  
                    comment = DMKM.this.getComment("Main.END_STATE"); 
                    args = new Object[]{new Integer(d.resultFlow)}; 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case START_STATE: { //  
                    d.vis.showNetwork(false);
                    break;
                }
                case 1: { //   .
                    d.vis.showNetwork(false);
                    break;
                }
                case 2: { //    ()
                    child.drawState(); 
                    break;
                }
                case 4: { //       ()
                    child.drawState(); 
                    break;
                }
                case 5: { //       ()
                    child.drawState(); 
                    break;
                }
                case 6: { //   ,   -    ()
                    child.drawState(); 
                    break;
                }
                case 7: { //    ()
                    child.drawState(); 
                    break;
                }
                case 8: { //      .
                    d.vis.showDiniz(false);
                    break;
                }
                case 9: { //      .
                    d.vis.showNetwork(true);
                    break;
                }
                case END_STATE: { //  
                    d.vis.showNetwork(true);
                    break;
                }
            }
        }
    }
}
